function [xb,yb] = CheckBoundary(x,y,xb,yb,TriPt,lowerElementLength,upperElementLength)

%********Checking in grain boundary**********

xb = [x(TriPt), xb(1,:)];
yb = [y(TriPt), yb(1,:)];
%too small: condense two nodes into the bisecting point on their
%element
for e = 1:(length(xb)-1)
    l = ((yb(e+1)-yb(e))^2+(xb(e+1)-xb(e))^2)^(1/2);
    
    if l < lowerElementLength && e < (length(xb)-1)
        xb(e) = (xb(e)+xb(e+1))/2;
        yb(e) = (yb(e)+yb(e+1))/2;
        xb(e+1:length(xb)-1) = xb(e+2:length(xb));
        yb(e+1:length(yb)-1) = yb(e+2:length(yb));
        xb = xb(1:length(xb)-1);
        yb = yb(1:length(yb)-1);
        
    end
    %when an element is removed, the loop will try to access an element
    %that doesn't exist at the end, so break as soon as the end is reached
    if e == length(xb)-1
        break
    end
end

%End element too small: delete second to last node
sln = length(xb) - 1;
l = ((yb(sln+1)-yb(sln))^2+(xb(sln+1)-xb(sln))^2)^(1/2);
if l < lowerElementLength
    xb(sln) = xb(sln + 1);
    yb(sln) = yb(sln + 1);
    xb = xb(1:length(xb)-1);
    yb = yb(1:length(yb)-1);
end

%too large: add a node at the bisecting point of the element

%for every element added, the e index needs to be increased in order to hit
%all points in the position vectors
add = 0;
for e = 1:(length(xb)-1)
    ee = e + add;
    l = ((yb(ee+1)-yb(ee))^2+(xb(ee+1)-xb(ee))^2)^(1/2);
    

    if l > upperElementLength
        newx = (xb(ee)+xb(ee+1))/2;
        newy = (yb(ee)+yb(ee+1))/2;
        xb(ee+2:length(xb)+1) = xb(ee+1:length(xb));
        xb(ee+1) = newx;
        yb(ee+2:length(yb)+1) = yb(ee+1:length(yb));
        yb(ee+1) = newy;
        add = add + 1;
    end
end

xb = xb(2:length(xb));
yb = yb(2:length(yb));
