function LocalH = LocalHmatrix(theta,l,L)
%This function takes a value of theta, length, and mobility to calculate
%and return the 4x4 local H matrix for an individual element.

%Calculate individual elements of H matrix
    L11 = 2*sin(theta)^2;
    L12 = -2*sin(theta)*cos(theta);
    L13 = sin(theta)^2;
    L14 = -sin(theta)*cos(theta);
    L21 = -2*sin(theta)*cos(theta);
    L22 = 2*cos(theta)^2;
    L23 = -sin(theta)*cos(theta);
    L24 = cos(theta)^2;
    L31 = sin(theta)^2;
    L32 = -sin(theta)*cos(theta);
    L33 = 2*sin(theta)^2;
    L34 = -2*sin(theta)*cos(theta);
    L41 = -sin(theta)*cos(theta);
    L42 = cos(theta)^2;
    L43 = -2*sin(theta)*cos(theta);
    L44 = 2*cos(theta)^2;
    
    %Assemble local H matrix for individual element
    LocalH = l/6/L*...
        [L11 L12 L13 L14;...
        L21 L22 L23 L24;...
        L31 L32 L33 L34;...
        L41 L42 L43 L44];