function LocalH = LocalHmatrixDiffusion(theta,l,L,M)
%This function takes a value of theta, length, and mobility to calculate
%and return the 4x4 local H matrix for an individual element.

ls = l^2;
s = sin(theta);
ss = s^2;
c = cos(theta);
cs = c^2;
u = L*l^2/5/M;
%Calculate individual elements of H matrix
    L11 = 2*l^2*sin(theta)^2;
    L12 = -2*l^2*sin(theta)*cos(theta);
    L13 = 5*l*sin(theta);
    L14 = l^2*sin(theta)^2;
    L15 = -l^2*sin(theta)*cos(theta);
    L16 = -l*sin(theta);
    L17 = -4*l*sin(theta);
    
    L21 = -2*l^2*sin(theta)*cos(theta);
    L22 = 2*l^2*cos(theta)^2;
    L23 = -5*l*cos(theta);
    L24 = -l^2*sin(theta)*cos(theta);
    L25 = l^2*cos(theta)^2;
    L26 = l*cos(theta);
    L27 = 4*l*cos(theta);
    
    L31 = 5*l*sin(theta);
    L32 = -5*l*cos(theta);
    L33 = 14 + 4*u;
    L34 = l*sin(theta);
    L35 = -l*cos(theta);
    L36 = 2 - u;
    L37 = -16 + 2*u;
    
    L41 = l^2*sin(theta)^2;
    L42 = -l^2*sin(theta)*cos(theta);
    L43 = l*sin(theta);
    L44 = 2*l^2*sin(theta)^2;
    L45 = -2*l^2*sin(theta)*cos(theta);
    L46 = -5*l*s;
    L47 = 4*l*s;
    
    L51 = L15;
    L52 = L25;
    L53 = L35;
    L54 = L45;
    L55 = 2*ls*cs;
    L56 = 5*l*c;
    L57 = -4*l*c;
    
    L61 = L16;
    L62 = L26;
    L63 = L36;
    L64 = L46;
    L65 = L56;
    L66 = 14 + 4*u;
    L67 = -16 + 2*u;
    
    L71 = L17;
    L72 = L27;
    L73 = L37;
    L74 = L47;
    L75 = L57;
    L76 = L67;
    L77 = 32 + 16*u;
    
    
    %Assemble local H matrix for individual element
    OriginalH = 1/6/L/l*...
        [L11 L12 L13 L14 L15 L16 L17;...
        L21 L22 L23 L24 L25 L26 L27;...
        L31 L32 L33 L34 L35 L36 L37;...
        L41 L42 L43 L44 L45 L46 L47;...
        L51 L52 L53 L54 L55 L56 L57;...
        L61 L62 L63 L64 L65 L66 L67;...
        L71 L72 L73 L74 L75 L76 L77];
    
    SecondH = OriginalH;
    %switch the rows
    SecondH(5:7,:) = OriginalH(4:6,:);
    SecondH(4,:) = OriginalH(7,:);
    
    FinalH = SecondH;
    %switch the columns
    FinalH(:,5:7) = SecondH(:,4:6);
    FinalH(:,4) = SecondH(:,7);
    
    LocalH = FinalH;
    